#if 0
  SCHEME
    gc_flip ()
    {
      SCHEME * scan;

      inline int sitting_duck (SCHEME * p) {
        return (p >= current_heap) && (p < (current_heap + heap_size));
      }

      inline int copied_duck (SCHEME * p) {
        return (p >= other_heap)   && (p < (other_heap + heap_size));
      }

      SCHEME *
        copy (SCHEME * p)
        {
          SCHEME * pp = (SCHEME *) *p;
          if (IMMEDIATE (pp)) {
            return pp;
          } else if (sitting_duck (pp)) {
            if (copied_duck ((SCHEME *) (*pp))) {
              // pp points into to_space, return the forwarding address
              return (SCHEME *) (*pp);
            } else {
              unsigned char tc = GET_TYPECODE (*pp);
              if (tc <= TC_LAST) {
                // p points at an object in from_space, copy it
                SCHEME * addr = free;
                ulong length = GET_TUPLE_LENGTH (*pp);
                ulong i;
                // copy tag, children
                for (i=0; i < length+1; i++) {
                  *free++ = *pp++;
                }
                // leave a forwarding address where the tag used to be
                *(SCHEME *)(*p) = (SCHEME) addr;
                return addr;
              } else {
                fprintf (stderr, "panic: Unknown Type Code in GC copy loop: *pp=0x%08x tc=0x%x\n", (long)(*pp), tc);
                exit (1);
              }
            }
          } else {
            // pp points outside of the heap
            return pp;
          }
        }

	  // fprintf (stderr, "gc()\n");

#define GC_NROOTS 7

      // place our roots
      scan = other_heap;
      free = scan + GC_NROOTS;
      scan[0] = (SCHEME) acc;
      scan[1] = (SCHEME) val;
      scan[2] = (SCHEME) lenv;
      scan[3] = (SCHEME) k;
      scan[4] = (SCHEME) code_object;
      scan[5] = (SCHEME) code_string;
	  scan[6] = (SCHEME) error_handler;
      
      // unpad limit
      limit = current_heap + heap_size;

      // copy the roots
      scan[0] = (SCHEME) copy (&(scan[0]));
      scan[1] = (SCHEME) copy (&(scan[1]));
      scan[2] = (SCHEME) copy (&(scan[2]));
      scan[3] = (SCHEME) copy (&(scan[3]));
      scan[4] = (SCHEME) copy (&(scan[4]));
      scan[5] = (SCHEME) copy (&(scan[5]));
	  scan[6] = (SCHEME) copy (&(scan[6]));
      
      // bump scan
      scan += GC_NROOTS;

      // scan loop
      
      while (scan < free) {
        if (IMMEDIATE (*scan)) {
          scan++;
        } else {
          SCHEME * p = scan + 1;
          unsigned char tc = GET_TYPECODE (*scan);

          switch (tc) {

		  case TC_SAVE_VAL: // save_val = { tag, val, k }
          case TC_TUPLE:    // tuple    = { tag, next, arg0, arg1 ...}
          case TC_VECTOR:   // vector   = { tag, v0, v1, ... }
          case TC_CODE:     // code     = { tag, constant-vector, code-string }
          case TC_SYMBOL:   // symbol   = { tag, string }
          case TC_CLOSURE:  // closure  = { tag, code, pc, lenv }
          case TC_SAVE:     // save     = { tag, k, val, lenv, code, pc }
          case TC_PAIR: {   // pair     = { tag, car, cdr }
            // copy everything
            ulong i;
            ulong length = GET_TUPLE_LENGTH (*scan);
            for (i=0; i < length; i++) {
              *p++ = (SCHEME) copy (p);
            }
            scan += length + 1;
          }
          break;

          case TC_STRING: {
            SCHEME length = GET_TUPLE_LENGTH (*scan);
            scan += length + 1;
          }
          break;

          default:
            fprintf (stderr, "panic: Unknown Type Code in GC scan loop: scan=0x%08x tc=0x%02x\n", (ulong)scan, tc);
            exit (-1);
            break;
          }
        }
      }
      // swap heaps
      { SCHEME * temp = current_heap; current_heap = other_heap; other_heap = temp; }
      // XXX we should swap them in the heap structure, too?

      // replace roots
      acc           =            current_heap[0];
      val           = (SCHEME *) current_heap[1];
      lenv          = (SCHEME *) current_heap[2];
      k             = (SCHEME *) current_heap[3];
      code_object   = (SCHEME *) current_heap[4];
      code_string   = (SCHEME *) current_heap[5];
	  error_handler	= (SCHEME *) current_heap[6];

      // maintain invariant
      code = (BYTECODE *) (&(code_string[2]));

      // set new limit
      limit = current_heap + (heap_size - 1024);

      // zero the from-space
      memset (other_heap, 0, heap_size);

      // fprintf (stderr, "collected %d words\n", free - current_heap);
      return (SCHEME) BOX_INTEGER (free - current_heap);
    }
