(let ((z '(1 2 3)))
  (define-macro (push x l) `(set! ,l (%cons ,x ,l)))
  (push 5 z)
  (cons 'sam z)
  )

(let ((z '(1 2 3)))

  (define-macro (pop <l>)
    `(let ((zzz (car ,<l>)))
       (set! ,<l> (cdr ,<l>))
       zzz))

  (define-macro (push <x> <l>)
    `(set! ,<l> (%cons ,<x> ,<l>)))

  (push 'a z)
  (%print z)
  (pop z))


(let ((z '(1 2 3)))
  (define (kons a b)
    (cons a b))
  (define-macro (pop l)
    `(let ((zzz (car ,l)))
       (set! ,l (cdr ,l))))
  (kons (pop z) (pop z)))


(let ()
  (define-macro dispatcher
    (lambda methods
      (let ((pairs (list 'quasiquote (map (lambda (name) `(name . ,name)) methods))))
	`(let ((table ,pairs))
	   (lambda (msg)
	     (let ((probe (%assq msg table)))
	       (if probe (%cdr probe) (error "no such method"))))))))
  (dispatcher read peek next read-all)
  )

(name . (unquote name))

(let ((table `((read . ,read) (next . ,next))))
  (lambda (msg)
    (let ((probe (%assq msg table)))
      (if probe (%cdr probe

;; we need a list of pairs
;; each pair consists of (name . (unquote name))
;; 

(define-macro (dispatcher . methods)
  (let ((pairs (list 'quasiquote (map (lambda (name) (cons name (list 'unquote name))) methods)))
		(table (gensym))
		(msg (gensym))
		(probe (gensym)))
	`(let ((,table ,pairs))
	   (lambda (,msg)
		 (let ((,probe (%assq ,msg ,table)))
		   (if ,probe
			   (%cdr ,probe)
			   (error "no such method")))))))


(let ()
  (define (one) 1)
  (define (two) 2)
  (define (three) 3)
  (define (four) 4)

  (define-macro (dispatcher . methods)
    (let ((pairs (list 'quasiquote (map (lambda (name) (cons name (list 'unquote name))) methods))))
      `(let ((table ,pairs))
	 (lambda (msg)
	   (let ((probe (%assq msg table)))
	     (if probe (%cdr probe) (error "no such method")))))))
  (dispatcher one two three four)
  )

(let ()
  (define (one) 1)
  (define (two) 2)
  (define (three) 3)
  (define (four) 4)

(define-macro (dispatcher . methods)
  (let ((pairs (list 'quasiquote (map (lambda (name) (cons name (list 'unquote name))) methods)))
		(table (gensym))
		(msg (gensym))
		(probe (gensym)))
	`(let ((,table ,pairs))
	   (lambda (,msg)
		 (let ((,probe (%assq ,msg ,table)))
		   (if ,probe
			   (%cdr ,probe)
			   (error "no such method")))))))


  (dispatcher one two three four)
  )

