
(define (make-server port)
  (let ((socket (%socket 2 1)))
    (print "socket:" socket)
    (print "bind" (%bind socket 0 0 0 0 port))
    (print "listen" (%listen socket 5))
    (let ((fd (%accept socket)))
      (let ((is (buffered-file fd 8192))
	    (os (buffered-file fd 8192)))
	(repl 0 is os)
	))))

(define (smtp-client)

  (define (read-line f)
    (let ((rc (f 'read-char)))
      (let loop ((ch (rc))
		 (line '()))
	(if (eof-object? ch)
	    (list->string (reverse line))
	    (cond ((eq? ch (integer->char 13))
		   (rc) ;; skip LF
		   (list->string (reverse line)))
		  (else
		   (loop (rc) (cons ch line))))))))

  (define write-line
    (let ((eol (list->string (list (integer->char 13) (integer->char 10)))))
      (lambda (s f)
	(let ((line (string-append s eol)))
	  ((f 'write-string) line)
	  ((f 'flush))))))

  (let ((ip (zero-terminate "192.168.200.6")))
    (let ((socket (%socket 2 1)))
      (%connect socket ip 25)
      (let ((infile (buffered-file socket 8192))
	    (outfile (buffered-file socket 8192)))
	(%print (read-line infile))
	(write-line "QUIT" outfile)
	(%print (read-line infile))
	(%close socket)))))
