
opcodes = {

  # /* opcodes with arguments: */
  'OP_PROC'		:'\n',
  'OP_SAVE'		:'S',
  'OP_LIT'		:'L',
  'OP_TUPLE'		:'T',
  'OP_STORE'		:'>',
  'OP_TEST'		:'?',
  'OP_PRIMOP'		:'%',
  'OP_VARREF'		:'V',
  'OP_CONSTANT'		:'C',
  'OP_BUILTIN'		:'B',
  'OP_ASSIGN'		:'!',

  # /* no-argument opcodes */
  'OP_RESTORE'		:'R',
  'OP_INVOKE'		:'I',
  'OP_JUMP'		:'J',
  'OP_PUSH_ENV'		:'Z',

  # /* opcodes with implied arguments */
  'OP_STORE0'		:'0',
  'OP_STORE1'		:'1',
  'OP_STORE2'		:'2',
  'OP_STORE3'		:'3',
  'OP_STORE4'		:'4',
  'OP_STORE5'		:'5',
  'OP_STORE6'		:'6',
  'OP_STORE7'		:'7',
  'OP_STORE8'		:'8',
  'OP_STORE9'		:'9',

  'OP_LEXREF_00'	:'a',
  'OP_LEXREF_01'	:'b',
  'OP_LEXREF_02'	:'c',
  'OP_LEXREF_03'	:'d',
  'OP_LEXREF_10'	:'e',
  'OP_LEXREF_11'	:'f',
  'OP_LEXREF_12'	:'g',
  'OP_LEXREF_13'	:'h',
  'OP_LEXREF_20'	:'i',
  'OP_LEXREF_21'	:'j',
  'OP_LEXREF_22'	:'k',
  'OP_LEXREF_23'	:'l',
  'OP_LEXREF_30'	:'m',
  'OP_LEXREF_31'	:'n',
  'OP_LEXREF_32'	:'o',
  'OP_LEXREF_33'	:'p',

  'OP_TUPLE_0'		:'.',
  'OP_TUPLE_1'		:';',
  'OP_TUPLE_2'		:'"',
  'OP_TUPLE_3'		:',',

  'OP_SAVE_VAL'		:'q',

}

primops = {
    'PRIM_ADD'			:'+',
    'PRIM_SUB'			:'-',
    'PRIM_MUL'			:'*',
    'PRIM_DIV'			:'/',
    'PRIM_MOD'			:'%',
    'PRIM_EQ'			:'=',
    'PRIM_GT'			:'>',
    'PRIM_LT'			:'<',
    'PRIM_AND'			:'&',
    'PRIM_OR'			:'|',
    'PRIM_GE'			:'}',
    'PRIM_LE'			:'{',
#    'PRIM_XOR'			:'^',
    'PRIM_CONS'			:'a',
    'PRIM_CAR'			:'b',
    'PRIM_CDR'			:'c',
    'PRIM_INTEGER_CHAR'		:'d',
    'PRIM_CHAR_INTEGER'		:'e',
    'PRIM_APPLY1'		:'f',
    'PRIM_NEW_TUPLE'		:'g',
    'PRIM_TUPLE_LENGTH'		:'h',
    'PRIM_TUPLE_REF'		:'i',
    'PRIM_TUPLE_SET'		:'j',
    'PRIM_BUILD_TUPLE'		:'k',
    'PRIM_UNDEFINED'		:'l',
    'PRIM_GC'			:'m',
    'PRIM_DUMP_IMAGE'		:'n',
    'PRIM_GET_TYPECODE'		:'o',
    'PRIM_GET_ENVIRONMENT'	:'p',
    'PRIM_ROOM'			:'q',
    'PRIM_INSNS'		:'r',
    'PRIM_GETCC'		:'s',
    'PRIM_PUTCC'		:'t',
    'PRIM_LEFT_SHIFT'		:'u',
    'PRIM_RIGHT_SHIFT'		:'v',
    'PRIM_SET_ERROR_HANDLER'	:'w',
    'PRIM_GET_ERROR_HANDLER'	:'x',
    }

def print_opcode_table():
    table = [None] * 256
    for key, value in opcodes.items():
        table[ord(value)] = (key, value)
    for i in range(256):
        if table[i] is None:
            print ' && TAG_OP_UNKNOWN,\t/* %d    */' % (i)
        else:
            name, char = table[i]
            print ' && TAG_%s,\t/* %d %s */' % (name, i, repr(char))

def print_primops_table():
    table = [None] * 256
    for key, value in primops.items():
        table[ord(value)] = (key, value)
    for i in range(256):
        if table[i] is None:
            print ' && TAG_PRIM_UNKNOWN,\t/* %d    */' % (i)
        else:
            name, char = table[i]
            print ' && TAG_%s,\t/* %d %s */' % (name, i, repr(char))

reverse_opcodes = [None] * 256
for name, val in opcodes.items():
    reverse_opcodes[ord(val)] = name

reverse_primops = [None] * 256
for name, val in primops.items():
    reverse_primops[ord(val)] = name

if __name__ == '__main__':
    import sys
    if '-p' in sys.argv:
        print "static void * primop_table[256] = {"
        print_primops_table()
        print "};"
    else:
        print "static void * opcode_table[256] = {"
        print_opcode_table()
        print "};"


